//#globals
var gDocFragmentAllHidden = false;
var gUriDir = location.href.substring( 0, location.href.lastIndexOf('/') + 1 );
var gUriPath = location.href.substring(gUriDir.length, location.href.length);
var gUriParts = gUriDir.split("/"); // break at the "/" 
var gUriLastSubdir = gUriParts[gUriParts.length-2];

//(+Tag Links)
$.fn.convertPlusLinks = function() {
        var regexpSqBracket = /\[\+[^\[]+\]/g; //Square bracket plus links handling here for backwards compatibility, but deprecated
		var regexpParen = /\(\+[^)]*\)/g;  //Parenthsis plus links handling
        this.each(function() {
            $(this).html(
                $(this).html().replace(regexpSqBracket,'<a href="$&.html?i&amp;" title="$&">$&</a>')
            );
            $(this).html(
                $(this).html().replace(regexpParen,'<a href="$&.html?i&amp;" title="$&">$&</a>')
            );
        });
        return $(this);
}

$('.markdownHtml').convertPlusLinks();


function setImageEach(self){
	self = $(self).children('img');
	self.css("display","block");
	self.css("border","1px");
	self.css("borderColor","red");
	self.css("border-style","solid");
	if( self.css("height").indexOf('40') > -1 ){
		self.css("height","300px");
		self.css("width","400px");	
	}else{
		if( self.css("height").indexOf('300') > -1 ){
			self.css("height","600px");
			self.css("width","800px");	
		}else{
			self.css("height","40px");
			self.css("width","65px");
			self.css("display","inline");
		}
	}
}
function setImage(size){
	var images = $('img.imageInline');
	$('.setImageTiny').css("background-color", "rgb(240,240,240)");
	$('.setImageSmall').css("background-color", "rgb(240,240,240)");
	$('.setImageLarge').css("background-color", "rgb(240,240,240)");
	$('.setImageHide').css("background-color", "rgb(240,240,240)");
	switch(size){
		case 'tiny':
			images.css("display","inline");
			images.css("height","40px");
			images.css("width","65px");
			$('.setImageTiny').css("background-color", "rgb(200,200,200)");
			images.css("display","inline");
			break;
		case 'small':
			images.css("display","block");
			images.css("height","300px");
			images.css("width","400px");
			$('.setImageSmall').css("background-color", "rgb(200,200,200)");
			break;
		case 'large':
			images.css("display","block");	
			images.css("height","600px");
			images.css("width","800px");
			$('.setImageLarge').css("background-color", "rgb(200,200,200)");
			break;
		case 'hide':
			images.css("display","none");
			$('.setImageHide').css("background-color", "rgb(200,200,200)");
			break;
		case 'remove':
			images.remove();
			$('.printImageDisplay').empty().append('<a href="#" onclick="window.location.reload();return false;">..</a>');
			break;
	}
}

function docFragmentHide(id){
	var frag = $('#' + id);
	if(frag.css('display') == 'none'){
		$('#' + id).show();
	}else{
		$('#' + id).each(function(){
			this.style.display = 'none';
		});
	}
}
function docFragmentHideAll(){
	var frag = $('.docFragmentWrapper');
	if(gDocFragmentAllHidden == true){
		frag.show();
		gDocFragmentAllHidden = false;
	}else{
		frag.hide();
		gDocFragmentAllHidden = true;
	}
}

function removefooter(){
	$('.footer').empty().append('&nbsp;');
	$('.footer').css('height', '1px');
	$('#footerLast').empty().append('&nbsp;');
	$('#footerLast').css('height', '1px');
	$('#utility_syntax_guide').css('margin', '0 10% 0 10%');
}

$('head').append('<link rel="stylesheet" type="text/css" media="all" href="styles/base-min.css">');
$('head').append('<link rel="stylesheet" type="text/css" media="all" href="styles/screen.css">');
$('head').append('<link rel="stylesheet" type="text/css" media="print" href="styles/print.css">');
$('head').append('<!--[if IE]><link rel="stylesheet" type="text/css" media="all" href="styles/ie.screen.css"><![endif]-->');
	

var eachResizeLink = '';

$('a').each(function(){
	var link = $(this)[0];
	
	var hrefRel = link.href.replace(gUriDir,'');
	var hrefRelUriPath = hrefRel.split('#');

	if( ( link.href.indexOf('#_') > -1 && (link.href.indexOf(hrefRelUriPath[0]) > -1) ) || ( (link.href == null) || (link.href == '') || (link.href == undefined) ) ) {
		//In-Page Anchor, so hands off (don't insert an icon)
	}else{
		//Insert inline image
		if( (link.href.indexOf('.png') > -1 || link.href.indexOf('.jpg') > -1 ) || (link.href.indexOf('.jpeg') > -1) || (link.href.indexOf('.gif') > -1) ) {
			//images
			eachResizeLink = '<a onclick="setImageEach(this); return false;" href="#">';
			$(this).after('&nbsp;' + eachResizeLink +'<img class="imageInline" src="' + link.href +  '" /></a>');
			$(this).after('&nbsp;<a class="external" target="_blank" href="' + link.href +  '"><img src="images/Utility.Screenshot.png" /></a>');
		}else if( link.href.indexOf('file:/') == -1 ){
			//external link
			$(this).after('&nbsp;<a class="external" target="_blank" href="' + link.href +  '"><img src="images/Utility.External.png" /></a>');
		}else{
			//internal link
			$(this).after('&nbsp;<a class="external" target="_blank" href="' + hrefRelUriPath +  '"><img src="images/Utility.Internal.png" /></a>');		
		}
    
	}
});


var linksHeading = '<h4 class="references">REFERENCES <small><a id="footerRemoveLink" href="#" onclick="removefooter(); return false;">(Remove)</a></small></h3><hr />';

//For Component .html files
if($('#footerLast').length == 0){
	$('.markdownHtml').after('<div class="footer">' + linksHeading + '</div>');
}
//For Compiled .html files
$('#footerLast').append(linksHeading);


var linkArr = jQuery.makeArray($('a'));
var linkArr2 = new Array();
for (var i = 0; i < linkArr.length; i++) {
	var hrefRel = linkArr[i].href.replace(gUriDir,'');
    hrefRelDsp = hrefRel.replace('%5B','[');
    hrefRelDsp = hrefRelDsp.replace('%5D',']');
    hrefRelDsp = hrefRelDsp.replace('%20',' ');
    
	var link = '<a href="' + hrefRel + '">' + hrefRelDsp + '</a>';
	if(hrefRel != ''){
		linkArr2.push(link + '<br />');
	}else{
		linkArr2.push(' ');
	}
}

//Sort list of References that are dynamically added to the bottom of page
linkArr2.sort();

var prevLink = ''; var curLink = '';
for (var i = 0; i < linkArr2.length; i++) {
	curLink = linkArr2[i];
	if(curLink != prevLink){
		$('.footer').append(linkArr2[i]);
		$('#footerLast').append(linkArr2[i]);
	}
	prevLink = curLink;
}

$('#footerFIX').empty(); //now remove innerHtml from bug workaround div


//Build Header with Link to root directory
$('h1').each(function(){
	var t = '<a class="setImageTiny" onclick="setImage(\'tiny\'); return false;" href="#">';
	var s = '<a class="setImageSmall" onclick="setImage(\'small\'); return false;" href="#">';
	var l = '<a class="setImageLarge" onclick="setImage(\'large\'); return false;" href="#">';
	var h = '<a class="setImageHide" onclick="setImage(\'hide\'); return false;" href="#">';
	var r = '<a class="setImageRemove" onclick="setImage(\'remove\'); return false;" href="#">';
	$(this).after('<div class="printImageDisplay">IMAGES: ' + t + 'Tiny</a> | ' + s + 'Small</a> | ' + l + 'Large</a> | ' + h + 'Hide</a> | ' + r + 'Remove</a>' + '</div>');
	$(this).append('<div class="navRoot"><a href=".">' + gUriLastSubdir + '</a></div>');
});

